// Copyright Epic Games, Inc. All Rights Reserved.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/GameModeBase.h"
#include "Http.h"
#include "EndlessVendettaGameMode.generated.h"

UCLASS(minimalapi)
class AEndlessVendettaGameMode : public AGameModeBase
{
	GENERATED_BODY()

public:
	AEndlessVendettaGameMode();

	UFUNCTION(Exec, Category = ExecFunctions)
	void KillAllEnemies();

	UFUNCTION(Exec, Category = ExecFunctions)
	void SetLocalAIAlertLevel(int NewAlertLevel);

	UPROPERTY(EditDefaultsOnly, BlueprintReadOnly, Category = "Telemetry")
	FString TelemetryURLEvents = "https://ev.api.philipwhite.dev/api/event";
	UPROPERTY(EditDefaultsOnly, BlueprintReadOnly, Category = "Telemetry")
	FString TelemetryURLUsers = "https://ev.api.philipwhite.dev/api/user";
	UPROPERTY(EditDefaultsOnly, BlueprintReadOnly, Category = "Telemetry")
	FString SessionID = "AAAAA";
	UPROPERTY(EditDefaultsOnly, BlueprintReadOnly, Category = "Telemetry")
	FString PlayerGUID = "aaaaaaaa-bbbb-cccc-dddd-eeeeeeeeeeee";

	UFUNCTION(BlueprintCallable, Category = "Telemetry")
	void SendEvent(FString EventKey, FString EventData);
	static FString GenerateUUID();

	virtual void BeginPlay() override;
};
